unit uFigur;  //Version 2 mit dem Vorfahren TFigur, nicht abstrakt.

interface

uses graphics,types,math;

type
  TFigur=class(TObject)
  protected
    Canvas:TCanvas;
    xM,yM,d:integer ; //d nicht public, sonst d<0 mglich
    procedure setd(neu:integer);
    function getM:TPoint;
    procedure setM(neu:TPoint);
  public
    farbe:TColor;
    constructor create(iCanvas:TCanvas;iFarbe:TColor;ixM,iyM,id:integer);
    property Mittelpkt:TPoint read getM write setM;
  end;

  TKreis=class(TFigur)
  protected
    procedure konstruieren;
  public
    procedure zeichnen;
    procedure loeschen;
    procedure verschieben(dx,dy:integer);
    property Radius:integer read d write setd;
  end;

 //-------------------------------------------------------------------------
  TQuadrat=class(TFigur)
  protected
    procedure konstruieren;
  public
    procedure zeichnen;
    procedure loeschen;
    procedure verschieben(dx,dy:integer);
    property Seitenlaenge:integer read d write setd;
  end;

 //-------------------------------------------------------------------------
  TStrecke=class(TObject)
    protected
    Canvas:TCanvas;
    xP,yP,xQ,yQ:integer ; //r nicht public, sonst r<0 mglich
    function getP:TPoint;
    procedure setP(neu:TPoint);
    function getQ:TPoint;
    procedure setQ(neu:TPoint);
    procedure konstruieren;
  public
    farbe:TColor;
    constructor create(iCanvas:TCanvas;iFarbe:TColor;ixP,iyP,ixQ,iyQ:integer);
    procedure zeichnen;
    procedure loeschen;
    procedure verschieben(dx,dy:integer);
    property Endpkt:TPoint read getQ write setQ;
    property Anfangspkt:TPoint read getP write setP;
    function Laenge:real;
  end;


implementation

//=====================TFigur===============================================
constructor TFigur.create(iCanvas:TCanvas;iFarbe:TColor;ixM,iyM,id:integer);
begin
  inherited create;
  //Initialisierungen
  Canvas:=iCanvas;
  farbe:=iFarbe;
  xM:=ixM; yM:=iyM;
  d:=max(id,0); //negative Werte verboten
end;

procedure TFigur.setd(neu:integer);
begin
  d:=max(0,neu); // d < 0 ausschlieen
end;

procedure TFigur.setM(neu:TPoint);
begin
  xM:=neu.X;
  yM:=neu.Y;
end;

function TFigur.getM:TPoint;
begin
  result:=point(xM,yM);
end;

//======================TKreis==============================================
procedure TKreis.konstruieren;
begin
  Canvas.ellipse(xM-d,yM-d,xM+d,yM+d);
end;

procedure TKreis.zeichnen;
begin
  canvas.Pen.color:=farbe;
  canvas.Brush.color:=farbe;
  konstruieren;
end;

procedure TKreis.loeschen;
begin
  canvas.Pen.color:=clbtnface;
  canvas.Brush.color:=clbtnface;
  konstruieren;
end;

procedure TKreis.verschieben(dx,dy:integer);
begin
  loeschen;
  xM:=xM+dx;
  yM:=yM+dy;
  zeichnen;
end;

//======================TQuadrat==============================================
procedure TQuadrat.konstruieren;
begin
  Canvas.rectangle(xM-d div 2,yM-d div 2,xM+d div 2,yM+d div 2);
end;

procedure TQuadrat.zeichnen;
begin
  canvas.Pen.color:=farbe;
  canvas.Brush.color:=farbe;
  konstruieren;
end;

procedure TQuadrat.loeschen;
begin
  canvas.Pen.color:=clbtnface;
  canvas.Brush.color:=clbtnface;
  konstruieren;
end;

procedure TQuadrat.verschieben(dx,dy:integer);
begin
  loeschen;
  xM:=xM+dx;
  yM:=yM+dy;
  zeichnen;
end;

//======================TStrecke==============================================
constructor TStrecke.create(iCanvas:TCanvas;iFarbe:TColor;ixP,iyP,ixQ,iyQ:integer);
begin
  inherited create;
  //Initialisierungen
  Canvas:=iCanvas;
  farbe:=iFarbe;
  xP:=ixP; yP:=iyP;
  xQ:=ixQ; yQ:=iyQ;
end;

procedure TStrecke.setP(neu:TPoint);
begin
  xP:=neu.X;
  yP:=neu.Y;
end;

function TStrecke.getP:TPoint;
begin
  result:=point(xP,yP);
end;

procedure TStrecke.setQ(neu:TPoint);
begin
  xQ:=neu.X;
  yQ:=neu.Y;
end;

function TStrecke.getQ:TPoint;
begin
  result:=point(xQ,yQ);
end;

procedure TStrecke.konstruieren;
begin
  Canvas.moveto(xP,yP);
  Canvas.lineto(xQ,yQ);
end;

procedure TStrecke.zeichnen;
begin
  canvas.Pen.color:=farbe;
  canvas.Brush.color:=farbe;
  konstruieren;
end;

procedure TStrecke.loeschen;
begin
  canvas.Pen.color:=clbtnface;
  canvas.Brush.color:=clbtnface;
  konstruieren;
end;

procedure TStrecke.verschieben(dx,dy:integer);
begin
  loeschen;
  xP:=xP+dx;
  yP:=yP+dy;
  xQ:=xQ+dx;
  yQ:=yQ+dy;
  zeichnen;
end;

function TStrecke.Laenge:real;
begin
  result:=sqrt(sqr(xq-xp)+sqr(yq-yP));
end;

END. 
